import org.icefaces.application.PortableRenderer;
import org.icefaces.application.PushRenderer;

import javax.annotation.PostConstruct;
import javax.el.ELContext;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;

/**
 * Created by lsteffen on 22/01/2016.
 */
@ManagedBean
@ViewScoped
public class PushView {

    private String text = "";
    private String pushGroup;
    private int count = -1;
    private PortableRenderer portableRenderer;

    public static PushView getBean() {
        ELContext elContext = FacesContext.getCurrentInstance().getELContext();
        PushView neededBean = (PushView) FacesContext.getCurrentInstance().getApplication()
                .getELResolver().getValue(elContext, null, "pushView");
        return neededBean;
    }

    @PostConstruct
    public void setup() {
        pushGroup = "g" + System.currentTimeMillis();
        PushRenderer.addCurrentView(pushGroup);
        portableRenderer = PushRenderer.getPortableRenderer();
    }

    public void startFlood() {
        count = 0;
        text = "";
        triggerPush();
    }

    public boolean continueFlood() {
        boolean c = count > -1 && count < 50;
        return c;
    }

    public void triggerPush() {
        text = text + "AsyncPush " + count++;
        portableRenderer.render(pushGroup);
    }

    public String getText() {
        return text;
    }
}
